/*********************************************************************
MODULE:         midmove.c 
PROGRAMMERS:    Yaoen Zhang and John White
DESCRIPTION:    It contains all functions called by rotate buttons.
                These three event handlers makes the continuous move
		possible. 
*******************************************************************/
#include "X11/X.h"
#include "p2.h"
#define ALARM 32000
#define REPEAT 50
extern void zoom_in_move();
extern void zoom_out_move();
extern void right_move();
extern void left_move();
extern void up_move();
extern void down_move();

/********************************************************************
FUCNTION:       mid_zoomin   
PURPOSE:        This is an event handler which handles continuous   
                moving forward.                           
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.                       
*******************************************************************/

mid_zoomin(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;		/* temp event buffer */
    int i,j, timer,alarm;	        /* loop integers     */
    double temp,tmp;
    timer=1;alarm=ALARM;	/* set the time value */


    while(timer<10){		/* check events to decide to stop */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11;
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)
       for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      zoom_in_move(w,data,NULL);}
    }
}
/********************************************************************
FUCNTION:       mid_zoomout
PURPOSE:        This is an event handler which handles continuous
                moving forward.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/

mid_zoomout(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;		/* temp event buffer */
    int i,j, timer,alarm;	        /* loop integers     */
    double temp,tmp;

    timer=1;alarm=ALARM;	/* set the time value */

    while(timer<10){		/* check events to decide to stop */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11;
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)
       for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      zoom_out_move(w,data,NULL);}
    }
}
/********************************************************************
FUCNTION:       mid_mup    
PURPOSE:        This is an event handler which handles continuous
                moving forward.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/

mid_mup(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;		/* temp event buffer */
    int i,j, timer,alarm;	        /* loop integers     */
    double temp,tmp;


    timer=1;alarm=ALARM;	/* set the time value */
    while(timer<10){		/* check events to decide to stop */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11;
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)
       for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      up_move(w,data,NULL);}
    }
}
/********************************************************************
FUCNTION:       mid_mdown
PURPOSE:        This is an event handler which handles continuous
                moving forward.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/

mid_mdown(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;		/* temp event buffer */
    int i,j, timer,alarm;	        /* loop integers     */
    double temp,tmp;

    timer=1;alarm=ALARM;	/* set the time value */

    while(timer<10){		/* check events to decide to stop */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11;
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)
       for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      down_move(w,data,NULL);}
    }
}
/********************************************************************
FUCNTION:       mid_mleft
PURPOSE:        This is an event handler which handles continuous
                moving forward.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/

mid_mleft(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;		/* temp event buffer */
    int i,j, timer,alarm;	        /* loop integers     */
    double temp,tmp;

    timer=1;alarm=ALARM;	/* set the time value */
    while(timer<10){		/* check events to decide to stop */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11;
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)
       for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      left_move(w,data,NULL);}
    }
}
/********************************************************************
FUCNTION:       mid_mright
PURPOSE:        This is an event handler which handles continuous
                moving forward.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/

mid_mright(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;		/* temp event buffer */
    int i,j, timer,alarm;	        /* loop integers     */
    double temp,tmp;

    timer=1;alarm=ALARM;	/* set the time value */

    while(timer<10){		/* check events to decide to stop */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11;
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)
       for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      right_move(w,data,NULL);}
    }
}
