/*********************************************************************
MODULE:         pbitinit.c

PROGRAMMERS:    John White and John White

DESCRIPTION:    This modules contains functions for initializing the
		tile editing functions. Includes: initializ, 
		PopupPromt, PopupHelp.
*******************************************************************/

#include "p2.h"
/*
 * Function Name: initialize
 * Description:   it initialize the tiling matrix .
 * Called:	  main
 */
extern void create_tiling();
extern void help_message();
void initialize()
{
int i,j,k;

for(k=0;k<MAX_TEXTURE_MAPS;k++)
    for(i=0;i<TILE_DIM;i++)
	for(j=0;j<TILE_DIM;j++){
           if((i+j)%2)
		tile[k][i][j] = NOT_SET;
 	   else 
		tile[k][i][j] = SET;
        }
}
/* Function Name: PopupPrompt
 * Description:   this function is called back the command button EDIT.  It 
 *                popup a shell widget to do bitmap editing.
 * Called:        command button EDIT
 */
void 
PopupPrompt(button, client_data, call_data)
Widget button;
canvas_data *client_data;
XtPointer call_data;
{
	Arg 	arg[5];
	Widget  popup,parent;   
 	Position x,y;
	Dimension width, height;
	Cardinal n;
	n=0;
	XtSetArg(arg[0], XtNwidth, &width); n++;
	XtSetArg(arg[1], XtNheight, &height); n++;
        parent=XtParent(button);
	XtGetValues(parent, arg,n);
	XtTranslateCoords(parent, (Position) (width / 5), 0, &x,&y);   
	n=0;
	XtSetArg(arg[0], XtNx, x); n++;
	XtSetArg(arg[1], XtNy, y); n++;
	popup =XtCreatePopupShell("Texture Design", 
				transientShellWidgetClass,button,arg,n);

        create_tiling(popup,client_data);
	XtPopup(popup,XtGrabExclusive); 
}

/* Function Name: PopupHelp
 * Description:   this function is called back the command button HELP. It
 *                popup a shell widget to show the help message.
 * Called:        command button HELP
 */
void
PopupHelp(button, client_data, call_data)
Widget button;
canvas_data *client_data;
XtPointer call_data;
{
        Arg     arg[5];
        Widget  popup,parent;
        Position x,y;
        Dimension width, height;
        Cardinal n;
        parent=XtParent(button);
        XtTranslateCoords(parent, 0, 0, &x,&y);
        n=0;
        XtSetArg(arg[0], XtNx, x); n++;
        XtSetArg(arg[1], XtNy, y); n++;
        popup =XtCreatePopupShell("Help Message",
                                transientShellWidgetClass,button,arg,n);

        help_message(popup,client_data);
        XtPopup(popup,XtGrabExclusive);
}

