/*********************************************************************
MODULE:         turn.c 

PROGRAMMERS:    Yaoen Zhang and John White

DESCRIPTION:    It contains all functions which relates to rotation
		Includes: mid_xrotate, mid_yrotate, mid_zrotate.
*******************************************************************/
#include "p2.h"
#define ALARM 32000
#define REPEAT  50
extern void rev_x_rotate();
extern void rev_y_rotate();
extern void rev_z_rotate();
  
/********************************************************************
FUCNTION:       mid_xrotate
PURPOSE:        This is an event handler which handles continuous
                rotation in the indicated direction.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/
mid_xrotate(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;
    int i,j,timer,alarm;
    double temp,tmp;
    timer=1;alarm=ALARM;


    while(timer<10){	/* check if the button released or left */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11; 	/* set the flag to get out of loop*/
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)	/* slow the rotation down a little bit*/
        for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      if(data->currentrotate==1)	/* check direction */
	rev_x_rotate(data,RIGHT);
      else
	rev_x_rotate(data,LEFT);}
    }
}
/********************************************************************
FUCNTION:       mid_yrotate
PURPOSE:        This is an event handler which handles continuous
                rotation in the indicated direction.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/
mid_yrotate(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;
    int i,j,timer,alarm;
    double temp,tmp;
    timer=1;alarm=ALARM;


    while(timer<10){	/* check if the button released or left */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11; 	/* set the flag to get out of loop*/
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)	/* slow the rotation down a little bit*/
        for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      if(data->currentrotate==1)	/* check direction */
	rev_y_rotate(data,RIGHT);
      else
	rev_y_rotate(data,LEFT);}
    }
}
/********************************************************************
FUCNTION:       mid_zrotate
PURPOSE:        This is an event handler which handles continuous
                rotation in the indicated direction.
PARAMETERS:     w - the widget which triggered this callback
                data - holds important screen and box information
                event - button press event.
*******************************************************************/
mid_zrotate(w,data,event)
 Widget w;
 canvas_data *data;
 XEvent    *event;
{
    XEvent tmpevent;
    int i,j,timer,alarm;
    double temp,tmp;
    timer=1;alarm=ALARM;


    while(timer<10){	/* check if the button released or left */
      while(XPending(data->w_display)){
            XNextEvent(data->w_display,&tmpevent);
            if(tmpevent.type==ButtonRelease || tmpevent.type==LeaveNotify)
            {
               timer=11; 	/* set the flag to get out of loop*/
            }
      }
      if(timer<10){
      temp=1.0001;
      for(i=0;i<alarm;i++)	/* slow the rotation down a little bit*/
        for(j=0;j<REPEAT;j++)
        tmp=temp*temp*temp*temp*temp;
      if(data->currentrotate==1)	/* check direction */
	rev_z_rotate(data,RIGHT);
      else
	rev_z_rotate(data,LEFT);}
    }
}
/*******************************************************************
FUNTION:        change_direct
PURPOSE:        This changes the direction of rotation.  
PARAMETERS:     sbox -- the calling widget
                data -- the canvas data structure
                client -- not used
********************************************************************/
void change_direct(sbox, data, client)
  Widget          sbox;
  canvas_data     *data;
  XtPointer       client;
{
    data->currentrotate= (data->currentrotate + 1)%2;
}

